#!/bin/bash

set -e

cd "$(dirname "$0")"

inputPath=Input
outputPath=Output
mkdir $outputPath

function run
{
	fullBinaryPath=$1
	frameworkName=$2
	binaryPath=$3
	wrapperName=$4
	
	binaryMovedPath=${binaryPath}Original
	fullBinaryMovedPath=${fullBinaryPath}Original
	
	cp -R $inputPath/$frameworkName $outputPath/
	
	mv $outputPath/$binaryPath $outputPath/$binaryMovedPath
	
	# TODO: use lipo to make just x64, no point in wasting space
	
	clang++ $wrapperName.m -dynamiclib -o $wrapperName.o -framework CoreFoundation -framework Foundation -fmodules -Xlinker -reexport_library $outputPath/$binaryMovedPath
	
	install_name_tool -change $fullBinaryPath $fullBinaryMovedPath $wrapperName.o
	
	mv $wrapperName.o $outputPath/$binaryPath
	
	codesign -f -s - $outputPath/$binaryPath
}

run "/System/Library/PrivateFrameworks/SkyLight.framework/Versions/A/SkyLight" "SkyLight.framework" "SkyLight.framework/Versions/A/SkyLight" "SkyLightWrapper"
run "/System/Library/Frameworks/CoreDisplay.framework/Versions/A/CoreDisplay" "CoreDisplay.framework" "CoreDisplay.framework/Versions/A/CoreDisplay" "CoreDisplayWrapper"